#include<stdio.h>
#include<stdlib.h>
#include<ctype.h>
#include <dirent.h>


/*test if file is an sgf-file by checking the last three characters in the 
file name*/
int issgf(char *name)
{int i=strlen(name);
	
	while(name[i]!='.' && i!=0)i--;
	if (name[i]=='.' && tolower(name[i+1])=='s' && tolower(name[i+2])=='g'
	&& tolower(name[i+3])=='f' && tolower(name[i+4])=='\0')return(1); else return(0);
}

/*Return file size in order to allocate enough memory for processing it*/
long FileSizeOf( FILE *fp )
{
    long int save_pos;
    long size_of_file;

    save_pos = ftell( fp );
    fseek( fp, 0L, SEEK_END );
    size_of_file = ftell( fp );
    fseek( fp, save_pos, SEEK_SET );
    return( size_of_file );
}

/*eliminate comments from sgf-string, this should ensure getting 
correct parentheses*/
long elimcomm(char* org, char* new)
{
 char incomment;
 long i,	//position in original sgf-string
      j;	//position in newly created sgf-string
 i=0;
 j=0;
 incomment=0;

 while(org[i]!=EOF)
 {
	/*look for a 'c' that might be the beginning of a comment*/
    while(org[i]!='C')
    {
    	if (org[i]==EOF){new[j]=EOF;return(j+1);}	//done
    	if (!isspace(org[i]))				//spaces are eliminated as well
    	{
    	  new[j]=org[i];			//not a space -> copy character
    	  j++;	
    	}
    	i++;
    }
    if(org[i+1]=='[' && org[i-1]!='P')		/*if we found 'c' check whether the command
						is comment or something else MIGHT HAVE TO BE
						EXTENDED!!

						If it is a comment ignore eveything until the
						next closing bracket*/
    {
       i++;
       incomment=1;
       while(incomment==1)
       {
	i++;
       if (org[i]==']' && org[i-1]!='\\')	//closing bracket found?
         {incomment=0; i++;
         }
       }
    }
    else
    {
      new[j]='C';				//if it wasn't a comment copy the 'c'
      i++;
      j++;
    }
 }
 return(j+1);				//return the size of the new sgf-string
}

/*find out the board size of the game in the sgf-file
the ti can only handle 9x9 (ti:1), 13x13 (ti:2), 19x19 (ti:3), 
so everything else will cause the program to discontinue the processing */
int getboardsize(char* temp)
{ char c[3];
  int s;
  long i=0;
  while(temp[i]!='S' || temp[i+1]!='Z' || temp[i+2]!='[' || temp[i]==EOF)i++;
  if (temp[i]==EOF)return(0);
  c[0]=temp[i+3];
  if (temp[i+4]!=']')
  {c[1]=temp[i+4];
   c[2]='\0';}
   else   c[1]='\0';
  s=atoi(c);
  if (s==9){return(1);}
  else if (s==13){return(2);}
  else if (s==19){return(3);}
  else return(0);
}

/*eliminate all but the tags for the moves (B[] o W[])*/
long elimextra(char* org, char* new)
{
  long i=0,j=0;
  char c;
  while (org[i]!=EOF)
  {
    c=org[i];
    if (c=='[') while(org[++i]!=']');		//ignore everything between brackets
    if (c=='(' || c==')'){new[j]=c;j++;}	//copy parentheses (variations are eliminated elsewhere)
    if (c==';' && (org[i+1]=='B' || org[i+1]=='W'))	//found move?? then copy it
    {
    	new[j++]=org[i++];			//;
    	new[j++]=org[i++];			//B o W
    	new[j++]=org[i++];			//[
        while(org[i]!=']'){new[j++]=org[i++];}	//copy until closing bracket
        new[j++]=org[i];
    }
    i++;
  }
  new[j]=EOF;
  return(j+1);
}

/*eliminate variations*/
long elimvar(char* org, char* new)
{
  int k=-1;	//parenthesis layer (number of opening p.)
  int i=0,j=0;	//position in old/new sgf-string
  int change=1; //has the string changed during the last processing loop

  while(change==1)	//as long as changes have occured
  {

  	change=0;	//nothing changed so far
  	i=0;j=0;k=1;	//reset parameters (k=1 because we want to have 1. Variation = main game thread)

  	while((org[i]!=')' || org[i+1]!='(') && org[i]!=EOF) 	//as long as we have not encountered p.
	{
		new[j++]=org[i++];}				//copy
		if(org[i]==EOF){new[j]=org[i];	
	}
	else						//we have a parenthesis (should be opening one)
	{
		change=1;
	        new[j++]=org[i++];
		while(k>0)				//while we are inside a variation we do not want
		{
			i++;
			if(org[i]=='(')k++;		//count opening
			if(org[i]==')')k--;		//and closing parentheses
		}
		i++;
		while(org[i]!=EOF)new[j++]=org[i++];	//only eliminate one variation at a time
							//maybe slow but works fine
		new[j]=org[i];
		new[j+1]='\0';
	}
	strcpy(org,new);				//exchange new and old
	
  }
  i=0;j=0;
  while(org[i]!=EOF)					//eliminate remaining parenteses
  {
    if (org[i]!='(' && org[i]!=')')new[j++]=org[i];
    i++;
  }
  new[j]=EOF;new[j+1]='\0';
  return(j+1);
}

/*find out who made the first move in the game*/
int getstartingcolor(char* org)
{
  long i=0;
  while(org[i]!=EOF)
  {
	  if(org[i]==';' && org[i+1]=='B' && org[i+2]=='[')return(0);	//;B[ is first
  	  if(org[i]==';' && org[i+1]=='W' && org[i+2]=='[')return(1);   //;W[ is first
	i++;
  }
  return(-1);	//otherwise error
}

/*determine file-name for converted sgf-file

MIGHT HAVE TO BE CHANGED FOR STRANGE FILE NAMES WITHOUT . IN NAME*/
void getnewname(char *old, char *new)
{
int i,j;
i=strlen(old)-1;
j=i;

while(old[i]!='.' && i>0)i--;	//find position of file extension
if (i==0)
{
	new[j+1]='.';new[j+2]='c';new[j+3]='s';new[j+4]='v';new[j+5]='\0';	//append cvs instead of sgf
	while(j>=0)new[j]=old[j--];
}else
{
	new[i+1]='c';new[i+2]='s';new[i+3]='v';new[i+4]='\0';
	while(i>=0)new[i]=old[i--];
}
}

/*determine stones placed on the board before the game started (handicap)*/
void getextrastones(char *org, char *temp, int color)
{
  int i,max,done,j;
  char col;
  char *temp2;

  temp2=(char *)malloc(sizeof(temp));

  i=0;done=0;
  if (color==1)col='W'; else if(color==0)col='B'; else col='';		//whose stones are wanted

  /*where does game start (only stones before game are wanted
  i will be the position in original sgf-string)*/
  while(org[i]!=EOF && done!=1)
  {
  	if(org[i]==';' && (org[i+1]=='B' || org[i+1]=='W') && org[i+2]=='[')done=1; else i++;
  }

  //set starting parameters
  done=0;
  max=i;	
  i=0;
  j=0;
  while(i<=max && done!=1)	//until done or start of the game is found
  {
        if(org[i]=='A' && org[i+1]==col && org[i+2]=='[')	//found tag for added stones?
        {
            i=i+2;
            while(org[i]=='[' && org[i+3]==']')		//while there is another stone -> copy
            {
		temp2[j]=org[i+1];
		temp2[j+1]=org[i+2];
		i=i+4;
		j=j+2;
            }
            temp[j]='\0';
            done=1;
        }
        else
        {i++;}
  }

  //now translate moves in ti-notation  
  max=j;
  i=0;
  j=0;
  while(i<max)
  {
	//write integer value of the coordinates and a newl-line
  	sprintf(&(temp[j]),"%i%i\r\n",temp2[i],temp2[i+1]);	
  	j=j+6;
  	i=i+2;;
  }
   	temp[j]='\0';
  	free(temp2);
}

/*extract the moves from sgf-string (by now only the main-game moves are left in it)
in the format readable for ti-goview*/
int getmoves(char *org, char *temp, int color)
{
  int i,j;
  char col[2]="BW";

  i=0;j=0;
  while(org[i]==';')	//while there is another move
  {
  	if(org[i]==';' && org[i+1]==col[color] && org[i+2]=='[')     //if next move has the right color
  	{
  	  if (org[i+3]==']'){temp[j]='0';temp[j+1]='\r';temp[j+2]='\n';i=i+4;j=j+3;}	//pass
  	  else
  	  if(org[i+4]==']'){printf("%c",org[i]);return(1);}			//only one coordinate - error
  	  else
  	  if(org[i+5]==']'){sprintf(&(temp[j]),"%i%i\r\n",org[i+3],org[i+4]);j=j+6;i=i+6;}	//copy coordinate
  	}
  	else{printf("%c",org[i]);return(1);}	//else return error
  	
  	if(color==0)color=1;else color=0;	//switch color (other person's move)
  }
  temp[j-2]='\0'; //vormals j
  return(0);
}

//process sgf-file with name name
void processfile(char *name)
{
  FILE *org, *neu;
  char *temp1,*temp2,c,*newname;
  long size,i,j;
  int bsize, startcolor;
  char *extrab,*extraw;

  org=fopen(name,"r");					//open file for reading
  if     (org==NULL) printf("file not found");		//not found
  else
  {
   size=FileSizeOf(org);				//get file size for allocating memory for string
   temp1=(char *)malloc(size*sizeof(char));
   temp2=(char *)malloc(size*sizeof(char));
   newname=(char *)malloc((strlen(name)+6)*sizeof(char));	//memory for new file name
   getnewname(name,newname);					//get new file name
   i=0;
   while((c=toupper(getc(org)))!=EOF){temp1[i++]=c;		//change everything to upper case letters
   }
   temp1[i]=EOF;
   bsize=getboardsize(temp1);			//get board size in sgf-file
   if(bsize)					//if board size ok proceed
   {
   	startcolor=getstartingcolor(temp1);	//get starting color
   	if(startcolor!=-1)			//if ok
   	{
 	  i=elimcomm(temp1,temp2);		//eliminate comments
 	  free(temp1);
   	  temp1=(char *)malloc(i*sizeof(char));
 	  memcpy(temp1,temp2,i);
   	  free(temp2);
   	  temp2=(char *)malloc(i*sizeof(char));
 	
        extrab=(char *)malloc(i*sizeof(char));	
        extraw=(char *)malloc(i*sizeof(char));
 	getextrastones(temp1,extrab,0);		//get extra stones for black and white
 	getextrastones(temp1,extraw,1);

	  i=elimextra(temp1,temp2);		//eliminate all but the move commands
 	  free(temp1);
   	  temp1=(char *)malloc(i*sizeof(char));
   	  for(j=0;j<i;j++)temp1[j]=temp2[j];
   	  free(temp2);
   	  temp2=(char *)malloc(i*sizeof(char));
 	
 	  i=elimvar(temp1,temp2);		//eliminate variations
 	  free(temp1);
   	  temp1=(char *)malloc(i*sizeof(char));
 	  memcpy(temp1,temp2,i);
   	  free(temp2);
   	  temp2=(char *)malloc(i*sizeof(char));

 	  i=getmoves(temp1,temp2,startcolor);	//get the moves of the game
 	  if (i==0)				//if there wasn't an error write the new file
 	  {
 	  	neu=fopen(newname,"w");

/*file format:
4	-indicates the file was created from sgf and therefor has other format than normally
boardsize (1,2,3)
5
list of extra stones black has
6
list of extra stones white has
7
who starts (0-black 1-white - i think)
list of moves*/

 	  	fprintf(neu,"4\r\n%d\r\n5\r\n%s6\r\n%s7\r\n%d\r\n%s",bsize,extrab,extraw,startcolor,temp2);
 	  	fclose(neu);
 	  }
 	  else fprintf(stderr,"\nerror while parsing the file\n\n");
   	free(extrab);
   	free(extraw);
 	}
 	else
 	{
   	  fprintf(stderr,"\ncould not determine who makes the first move\n\n");
 	}
   }
   else
   {
  	fprintf(stderr,"\nboardsize not supported\n\n");
   }
   free(temp1);
   free(temp2);
   free(newname);
   fclose(org); }
}

/*2 possibilities for calling the program
without parameters: all sgf-files in current directory are converted

list of file names as parameters (no wildcards) - those are converted*/
int main(int argc, char *argv[])
{
      DIR *dip;
      struct dirent *dit;
      int i = 0, length;
	char *old;

        if (argc==1)	//no parameters
        {
            if ((dip = opendir(".")) == NULL) 		//open directory
        	{
                	printf("could not open current directory\n\n");
                	return 0;
        	}
  	    while ((dit = readdir(dip)) != NULL)	//if no problem reading next directory entry
        	{
                	i++;
			length=strlen(dit->d_name);
			old=(char *)malloc(length*(sizeof(char)));
			strcpy(old,dit->d_name);

			if(issgf(old))			//if sgf-file process it
			{
				printf("processing %s\n",old);
				processfile(old);
			}
			free(old);
        	}
	     if (closedir(dip) == -1)
        	{
                	perror("closedir");
                	return 0;
        	}

         }
	else		//list of parameters was given - process one file at a time
	{
		i=1;
		while(i<argc)
		{	printf("processing %s\n",argv[i]);
			processfile(argv[i++]);
		}
	}
        return 1;	//return value doesn't really matter

}